<template>
  <div class="content">
    <br><br>
    <b-card v-if="user">
        <template v-slot:header>
          <h5><b-icon icon="person-fill"/> O meu perfil</h5>
        </template>

        <h3>{{user.username}}</h3>
        <h4 class="lead">{{user.email}}</h4>
        <br>
        <p><strong class>Jogos efetuados: </strong>{{user.gamesPlayed}}</p>
        <p><strong class>Vitórias: </strong>{{user.victorys}} <span v-show="user.victorys">(<span :style="{'color' : getVictorysColor(user)}">{{ Math.round((user.victorys / user.gamesPlayed) * 100) }}%</span>)</span></p>
        <p><strong class>Derrotas: </strong>{{user.gamesPlayed - user.victorys}}</p>
        <p v-show="user.gamesPlayed"><strong class>Precisão: </strong>{{Math.round((user.hits / user.shots) * 100)}}%</p>
        <br>
        <h4>Mudar Password</h4>
        <br>
        <b-form-group
          id="password"
          label="Introduza a sua nova password:"
          label-for="input-1"
          :invalid-feedback="npLengthIF"
          :state="npLength"
        >
          <b-form-input id="input-1" v-model="newPassword" :state="npLength" type="password" trim></b-form-input>
        </b-form-group>
        <b-form-group
          id="confirm-password"
          label="Confirme a sua nova password:"
          label-for="input-2"
          :invalid-feedback="cpIF"
          :state="cpState"
        >
          <b-form-input id="input-2" v-model="confirmPassword" :state="cpState" type="password" trim></b-form-input>
        </b-form-group>
      
        <b-form-group
          id="old-password"
          label="Introduza a sua password antiga:"
          label-for="input-2"
          :invalid-feedback="opLengthIF"
          :state="opLength"
        >
          <b-form-input id="input-3" v-model="oldPassword" type="password"  :state="opLength" trim></b-form-input>
        </b-form-group>
        <br>
        <b-button variant="success" class="float-right" v-on:click="handleChange" ><b-icon icon="lock"/> Mudar Password</b-button>

        



    </b-card>
    <br>
  </div>
</template>

<style>


</style>

<script>
// @ is an alias to /src
//import HelloWorld from '@/components/HelloWorld.vue'

import UserService from '@/services/User'


export default {
  name: 'home',
  components: {
   
  },
  data : function () {
    return {
      user : null,
      newPassword: "",
      confirmPassword : "",
      oldPassword: ""
    }
  }
  ,
  async mounted() {
    let user = await UserService.getUser();
    this.user = user;

  },
  methods: {
    getVictorysColor(userData) {
      if(userData.victorys > userData.gamesPlayed / 2)
        return 'green'

      return 'red';

    },
    handleChange: async function() {
      const newPassword = this.newPassword;
      const oldPassword = this.oldPassword;

      if(this.npLength && this.cpState && this.opLength) {
        
        let response = await UserService.setPassword(newPassword, oldPassword);

        if(response.error) {
          if(response.error == "INVALID_OLD") {
            this.$bvModal.msgBoxOk('Password antiga errada!', {
              title: 'Erro',
              size: 'md',
              okVariant: 'danger',
              centered: true
            });

          } else if (response.error == "PWD_LEN"){
            this.$bvModal.msgBoxOk('A nova password terá de ter mais de 5 caracteres!', {
              title: 'Erro',
              size: 'md',
              okVariant: 'danger',
              centered: true
            });
          } else {
            this.$bvModal.msgBoxOk('Ocorreu um erro inesperado', {
              title: 'Erro',
              size: 'md',
              okVariant: 'danger',
              centered: true
            });

          }

        } else if (response.newPassword && response.newPassword == "OK") {
            this.$bvModal.msgBoxOk('A password foi modificada com sucesso!', {
              title: 'Password Modificada!',
              size: 'md',
              okVariant: 'success',
              centered: true
            });

        } else {
            this.$bvModal.msgBoxOk('Ocorreu um erro inesperado', {
              title: 'Erro',
              size: 'md',
              okVariant: 'danger',
              centered: true
            });

        }

        
      }
        
    }
  },
  computed: {
    npLength : function() {
      if(this.newPassword.length == 0) return null;

      return (this.newPassword.length > 5  || this.newPassword.length == 0) ? true : false
    },
    npLengthIF : function() {
      return this.newPassword.length > 5 ? null  : "A password deve ter mais de 5 caracteres.";
    },
    opLength : function() {
      if(this.oldPassword.length == 0) return null;

      return this.oldPassword.length > 5 ? true : false
    },
    opLengthIF : function() {
      return this.oldPassword.length > 5 ? null  : "A password deve ter mais de 5 caracteres.";
    },
    cpState : function() {
      if(this.confirmPassword.length == 0) return null;

      if(this.newPassword == this.confirmPassword) return true;

      return false;

    },
    cpIF: function () {
      if(this.newPassword != this.confirmPassword)
        return "A nova password e a confirmação têm de ser iguais.";
      return null;
    }

  }
}
</script>
